import numpy as np

def sum_tests(f, arr, chop_x, chop_y):
    piece = arr[chop_x:, chop_y:]
    s = 0
    for cx, i in enumerate(range(chop_x, 3)):
        for cy, j in enumerate(range(chop_y, 3)):
            if not (i or j):
                continue
            t = np.pad(piece[:-cx or None, :-cy or None], ((i, 0), (j, 0)))
            s += f(t)
    return s

def f(arr):
    if arr[1, 1]:
        return arr[1, 2]
    else:
        return arr[1, 0]

def is_nc(f):
    for n in range(512):
        arr = (n & 1 << np.arange(9).reshape((3, 3))).astype(bool)
        if (f(arr) !=
            arr[0, 0]
            + sum_tests(f, arr, True, False)
            + sum_tests(f, arr, False, True)
            - sum_tests(f, arr, False, False)
            - sum_tests(f, arr, True, True)
           ):
            return False
    return True

def fofn(n):
    def f(arr):
        return (n >> int(np.sum(arr * (1 << np.arange(9).reshape((3, 3)))))) & 1
    return f

def entry(n):
    return is_nc(fofn(n))
